package ua.in.hutorny.otj.exer6;

public class SpecializationExercise {
	public void run() {
		Person tom = new Person("Tom");
		Person mary = new Person("Mary");
		Person paul = new Person("Paul");
		reveal(tom);
		reveal(mary);
		reveal(paul);
		new Pedagogue(tom);
		new Medic(mary);
		new Pedagogue(paul);
		new Medic(paul);
		
		reveal(tom);
		reveal(mary);
		reveal(paul);
		
		Doctor doctor = (Doctor) mary.castAs(Doctor.class); 
		System.out.println(doctor.cure());

		Teacher teacher = (Teacher) tom.castAs(Teacher.class);
		System.out.println(teacher.teach());

		teacher = (Teacher) paul.castAs(Teacher.class);
		System.out.println(teacher.teach());
		
		doctor = (Doctor) paul.castAs(Doctor.class);
		System.out.println(doctor.cure());
		Person whois = (Person) doctor.castAs(Person.class);
		reveal(whois);
		
	}
	static void reveal(Person person) {
		System.out.println((person.talk()+ ", " + person.name() + ". " + person.wash()));
	}
}
